aboutsummaryrefslogtreecommitdiff
path: root/dwm/Repositories/st/st-copyout
diff options
context:
space:
mode:
authorbard <[email protected]>2024-04-15 06:24:14 -0400
committerbard <[email protected]>2024-04-15 06:24:14 -0400
commit168120d4068eff9816c11f0503738c12861821ae (patch)
tree635e839eeca920432fcaa8417b282e074e84a4c2 /dwm/Repositories/st/st-copyout
initial commit
Diffstat (limited to 'dwm/Repositories/st/st-copyout')
-rwxr-xr-xdwm/Repositories/st/st-copyout13
1 files changed, 13 insertions, 0 deletions
diff --git a/dwm/Repositories/st/st-copyout b/dwm/Repositories/st/st-copyout
new file mode 100755
index 0000000..0d19e5a
--- /dev/null
+++ b/dwm/Repositories/st/st-copyout
@@ -0,0 +1,13 @@
+#!/bin/sh
+# Using external pipe with st, give a dmenu prompt of recent commands,
+# allowing the user to copy the output of one.
+# xclip required for this script.
+# By Jaywalker and Luke
+tmpfile=$(mktemp /tmp/st-cmd-output.XXXXXX)
+trap 'rm "$tmpfile"' 0 1 15
+sed -n "w $tmpfile"
+sed -i 's/\x0//g' "$tmpfile"
+ps1="$(grep "\S" "$tmpfile" | tail -n 1 | sed 's/^\s*//' | cut -d' ' -f1)"
+chosen="$(grep -F "$ps1" "$tmpfile" | sed '$ d' | tac | dmenu -p "Copy which command's output?" -i -l 10 | sed 's/[^^]/[&]/g; s/\^/\\^/g')"
+eps1="$(echo "$ps1" | sed 's/[^^]/[&]/g; s/\^/\\^/g')"
+awk "/^$chosen$/{p=1;print;next} p&&/$eps1/{p=0};p" "$tmpfile" | xclip -selection clipboard